
/***********************************************************************
 * $Id: simulator.h,v 1.13 92/04/20 16:08:44 drew Exp $
 ***********************************************************************/

#ifndef SIMULATOR_H
#define SIMULATOR_H

#include <xerion/config.h>

/***********************************************************************
 * Useful typedefs
 ***********************************************************************/
#ifndef REAL_DEFINED
#define REAL_DEFINED
#ifdef DOUBLE
typedef double	Real ;
#else
typedef float	Real;
#endif
#endif

#ifndef _XtIntrinsic_h
#ifndef _ITF_
typedef char	Boolean	;
#endif
#ifndef STRING_DEFINED
typedef char	*String ;
#endif
#endif				/* _XtIntrinsic_h */

typedef int	Action,   (*ActionPtr)() ;
typedef void	Proc,     (*ProcPtr) ARGS(()) ;
typedef int	IntFunc,  (*IntFuncPtr)() ;
typedef Real	RealFunc, (*RealFuncPtr)() ;

#ifndef FALSE
#define FALSE	(Boolean)0
#endif
#ifndef TRUE
#define TRUE	(Boolean)1
#endif

/***********************************************************************
 * Predefinitions of external functions
 * itf.h predefines malloc etc. as char *, so don't redo them here
 ***********************************************************************/

/***********************************************************************
 * Predefinitions of Object types
 ***********************************************************************/
typedef struct UnitRec		*Unit ;
typedef struct LinkRec		*Link ;
typedef struct GroupRec		*Group ;
typedef struct ExampleSetRec	*ExampleSet ;
typedef struct NetRec		*Net ;

/***********************************************************************
 * Now include the Object header files
 ***********************************************************************/
#include <xerion/mask.h>
#include <xerion/methods.h>

#include <xerion/link.h>
#include <xerion/unit.h>
#include <xerion/group.h>
#include <xerion/example.h>
#include <xerion/net.h>
#include <xerion/connect.h>
#include <xerion/traverse.h>
#include <xerion/access.h>

#endif				/* SIMULATOR_H */
