
/**********************************************************************
 * $Id: lex.h,v 1.3 92/04/20 16:10:20 drew Exp $
 **********************************************************************/

/**********************************************************************
 *	Copyright 1990,1991,1992 by The University of Toronto,
 *		       Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute,  and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided  that the above copyright notice  appears in all copies and
 * that both the copyright notice and this permission notice  appear in
 * supporting documentation, and  that  the  name of The University  of
 * Toronto  not  be used  in advertising   or publicity pertaining   to
 * distribution  of   the software   without  specific, written   prior
 * permission.  The  University  of Toronto  makes   no representations
 * about the  suitability  of  this software  for  any purpose.   It is
 * provided "as is" without express or implied warranty.
 *
 * THE  UNIVERSITY OF  TORONTO DISCLAIMS ALL WARRANTIES  WITH REGARD TO
 * THIS SOFTWARE,  INCLUDING ALL  IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT  SHALL THE UNIVERSITY  OF TORONTO BE LIABLE
 * FOR ANY SPECIAL,  INDIRECT OR CONSEQUENTIAL  DAMAGES  OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF  USE, DATA OR PROFITS,  WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE  OR OTHER TORTIOUS ACTION, ARISING
 * OUT  OF OR  IN  CONNECTION   WITH  THE  USE OR  PERFORMANCE  OF THIS
 * SOFTWARE.
 **********************************************************************/

#ifndef LEX_H
#define LEX_H

#define LEX_N_CHARS 128
#define LEX_CM 0x7F
#define LEX_TABLE (4 * LEX_N_CHARS + 2 * sizeof(int))

typedef struct LEX_STACK {
  char **arg_end;
  char *string_end;
  char *syntax;
} LEX_STACK;


extern char    *LexInit  ARGS((int size, char *space, HASH_TABLE *ht));
extern char    *LexReinit	 ARGS((char *space));
extern char    *LexMem	 ARGS((int size, char *space));
extern char    *LexMakeSyntax	 ARGS((int o_type, int q_break, char *s_chars,
				       char *w_chars, char *o_chars, 
				       char *q_chars, char *e_chars, 
				       char *c_chars, char *lookup));
extern char    *LexSetSyntax	 ARGS((char *lookup));
extern char   **LexAnalyse	 ARGS((char *syntax, char *line, int *tokc));
extern char   **LexAnalyseAdd	 ARGS((char *syntax, char *line, int *tokc));
extern char   **LexAnalysePush	 ARGS((char *syntax, char *line, int *tokc, 
				       LEX_STACK *lex_stack));
extern void	LexAnalysePop	 ARGS((LEX_STACK *lex_stack));


#define LEX_SP_BF_TOK	0x1
#define LEX_IS_OP	0x2
#define LexQuotedTok(s) ((s)[-2])
#define LexSpBefore(s) ((s)[-1] & LEX_SP_BF_TOK)
#define LexIsOperator(s)  ((s)[-1] & LEX_IS_OP)

#endif				/* LEX_H */
