
/**********************************************************************
 * $Id: layoutUtils.h,v 1.6 92/02/26 16:25:04 xerion Exp $
 **********************************************************************/

/**********************************************************************
 *	  Copyright 1990,1991 by The University of Toronto,
 *		      Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its  documentation for  any purpose is  hereby granted  without
 * fee, provided that the above copyright notice appears in all copies
 * and  that both the  copyright notice  and   this  permission notice
 * appear in   supporting documentation,  and  that the  name  of  The
 * University  of Toronto  not  be  used in  advertising or  publicity
 * pertaining   to  distribution   of  the  software without specific,
 * written prior  permission.   The  University of   Toronto makes  no
 * representations  about  the  suitability of  this software  for any
 * purpose.  It  is    provided   "as is"  without express or  implied
 * warranty.
 *
 * THE UNIVERSITY OF TORONTO DISCLAIMS  ALL WARRANTIES WITH REGARD  TO
 * THIS SOFTWARE,  INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT SHALL THE UNIVERSITY OF TORONTO  BE LIABLE
 * FOR ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL  DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR  PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT  OF  OR  IN  CONNECTION WITH  THE  USE  OR PERFORMANCE  OF THIS
 * SOFTWARE.
 *
 **********************************************************************/

#ifndef LAYOUT_UTILS_H
#define LAYOUT_UTILS_H

#ifndef FALSE
#define FALSE	((int)0)
#endif

#ifndef TRUE
#define TRUE	(~(int)0)
#endif

#ifndef MIN
#define MIN(x, y)	((x) < (y) ? (x) : (y))
#endif

typedef enum SectionType { All, Sect, Next, Blank, Fill, End } SectionType ;
typedef enum Mode 	 { Major, Minor, Activity, Unknown } Mode ;

typedef struct Section {
  SectionType	type ;
  char		*name ;
  int		from ;
  int		size ;
} Section ;

extern int	layoutInputLine ;

extern void	resetCurrentRow() ;
extern void	incrementCurrentRow() ;
extern int	getCurrentRow() ;

extern void	resetLastLaid() ;

extern Section	*buildSections ARGS((char	**argv,  int	argc)) ;
extern Section	*fillSections  ARGS((Section	*section, int	perRow)) ;

#endif				/* LAYOUT_UTILS_H */
