
/**********************************************************************
 * $Id: simUtils.c,v 1.4 92/04/20 16:16:13 drew Exp $
 **********************************************************************/

/**********************************************************************
 *	Copyright 1990,1991,1992 by The University of Toronto,
 *		       Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute,  and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided  that the above copyright notice  appears in all copies and
 * that both the copyright notice and this permission notice  appear in
 * supporting documentation, and  that  the  name of The University  of
 * Toronto  not  be used  in advertising   or publicity pertaining   to
 * distribution  of   the software   without  specific, written   prior
 * permission.  The  University  of Toronto  makes   no representations
 * about the  suitability  of  this software  for  any purpose.   It is
 * provided "as is" without express or implied warranty.
 *
 * THE  UNIVERSITY OF  TORONTO DISCLAIMS ALL WARRANTIES  WITH REGARD TO
 * THIS SOFTWARE,  INCLUDING ALL  IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT  SHALL THE UNIVERSITY  OF TORONTO BE LIABLE
 * FOR ANY SPECIAL,  INDIRECT OR CONSEQUENTIAL  DAMAGES  OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF  USE, DATA OR PROFITS,  WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE  OR OTHER TORTIOUS ACTION, ARISING
 * OUT  OF OR  IN  CONNECTION   WITH  THE  USE OR  PERFORMANCE  OF THIS
 * SOFTWARE.
 *
 **********************************************************************/

#include <stdio.h>
#include <varargs.h>

#include <xerion/simulator.h>
#define _SOURCE
#include "simUtils.h"
#undef _SOURCE

int	simErrno ;

char	*simErrString[] = {
  "Unknown simulator error",
  "Malloc returned a NULL value",
  "Bad array size"
  } ;
  
/***********************************************************************
 *	Name:		simError
 *	Description:	produces a message on standard error output,
 *			describing a simulator error and sets the integer
 *			value simerrno.
 *	Parameters:	
 *		int	simerrno - the error number to set
 *		char	*format - a format string (printf style) and
 *				associated args. simErr prints this
 *				string, a colon and a blank then a standard
 *				error message.
 *	Return Value:	NONE
 ***********************************************************************/
void	simError(va_alist)
  va_dcl 
{
  va_list 	args ;
  char		*format ;

  va_start(args) ;
  simErrno = va_arg(args, int) ;
  format   = va_arg(args, char *) ;

  if (format != NULL) {
    vfprintf(stderr, format, args) ;
    fprintf(stderr, ": ") ;
  }
  va_end(ap);

  if (simErrno < 0 || simErrno > MAX_SIMERRNO)
    simErrno = 0 ;
  fprintf(stderr, "%s\n", simErrString[simErrno]) ;
}
/**********************************************************************/
