
/**********************************************************************
 * $Id: NetworkP.h,v 1.9 92/04/20 16:16:59 drew Exp $
 **********************************************************************/

/**********************************************************************
 *	Copyright 1990,1991,1992 by The University of Toronto,
 *		      Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its  documentation for  any purpose is  hereby granted  without
 * fee, provided that the above copyright notice appears in all copies
 * and  that both the  copyright notice  and   this  permission notice
 * appear in   supporting documentation,  and  that the  name  of  The
 * University  of Toronto  not  be  used in  advertising or  publicity
 * pertaining   to  distribution   of  the  software without specific,
 * written prior  permission.   The  University of   Toronto makes  no
 * representations  about  the  suitability of  this software  for any
 * purpose.  It  is    provided   "as is"  without express or  implied
 * warranty.
 *
 * THE UNIVERSITY OF TORONTO DISCLAIMS  ALL WARRANTIES WITH REGARD  TO
 * THIS SOFTWARE,  INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT SHALL THE UNIVERSITY OF TORONTO  BE LIABLE
 * FOR ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL  DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR  PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT  OF  OR  IN  CONNECTION WITH  THE  USE  OR PERFORMANCE  OF THIS
 * SOFTWARE.
 *
 **********************************************************************/

/* Private definitions for Network widget */

#ifndef _NetworkP_h
#define _NetworkP_h

#include <X11/CoreP.h>
#include <xerion/Network.h>

typedef struct {
  XRectangle	back ;
  XRectangle	valueRectangle ;
  XSegment	valueSegment ;
} UnitDisplayRecP ;

typedef struct {int empty;} NetworkClassPart;

typedef struct _NetworkClassRec {
    CoreClassPart	core_class;
    NetworkClassPart	network_class;
} NetworkClassRec;

extern NetworkClassRec networkClassRec;

typedef struct _NetworkPart {
  /* resources */
  XtStyle		unitBackgroundStyle ;
  Pixel			unitBackground ;
  Pixel			negativeColor ;
  Pixel			positiveColor ;

  Dimension		unitHeight ;
  Dimension		unitWidth ;
  Dimension		unitBorderWidth ;
  Dimension		unitSep ;
  Boolean		rowColumnMode ;
  int			numUnits ;
  UnitDisplayRec	*unitArray ;
  float			*maxValuePtr ;
  Boolean		fixedMax ;
  int			increment ;

  XtCallbackList	queryCallback ;	     /* the callback for queries */
  XtCallbackList	motionCallback ;     /* the callback for motion */
  XtCallbackList	changeValueCallback ;/* the callback for changes */

  /* private data */
  Boolean		changeBackgroundPixmap ;
  Pixmap		unitBackgroundPixmap ; /* the unit background pixmap */
  float			maxValue ; 	/* the max unit value (for scaling) */
  UnitDisplayRecP	*unitArrayP ; 	/* array of recs etc for units */
  GC			borderGC ; 	/* the gc for the unit borders */
  GC			backGC ; 	/* the GC for the unit backgrounds */
  GC			negativeGC ;	/* the GC for positive values */
  GC			positiveGC ; 	/* the GC for negative values */
  Region		exposedRegion ;	/* The most recently exposed region */
  GC			motionGC ; 	/* the GC for moving units */
  XRectangle		lastRect ;	/* the last place we drew for motion */
  int			motionIdx ;     /* index of the unit we're moving */
} NetworkPart;

typedef struct _NetworkRec {
    CorePart		core;
    NetworkPart		network;
} NetworkRec;

#endif /* _NetworkP_h */
