#include <simulator.h>
#include "dbm.h"

/*********************************************************************
 * 				Lesioning
 *********************************************************************/
void		lesionUnit(unit)
  Unit		unit ;
{
  unit->output = 0.0 ;
  Mlesioned(unit) = TRUE ;
  Mcompiled(unit->net) = FALSE ;
}
void		unlesionUnit(unit)
  Unit		unit ;
{
  Mlesioned(unit) = FALSE ;
  Mcompiled(unit->net) = FALSE ;
}
Boolean		isLesionedUnit(unit)
  Unit		unit ;
{
  return Mlesioned(unit) ;
}

void		lesionLink(link)
  Link		link ;
{
    link->deriv = 0.0 ;
    MlesionedWeight(link) = link->weight ;
    setNaN(link->weight) ;
    Mlesioned(link) = TRUE ;
    Mcompiled(link->postUnit->net) = FALSE ;
}
void		unlesionLink(link)
  Link		link ;
{
  if (Mlesioned(link)) link->weight = MlesionedWeight(link) ;
  Mlesioned(link) = FALSE ;
  Mcompiled(link->postUnit->net) = FALSE ;
}
Boolean		isLesionedLink(link)
  Link		link ;
{
  return Mlesioned(link) ;
}
